---
title: Expressions and operators
slug: Web/JavaScript/Reference/Operators
tags:
  - JavaScript
  - Landing page
  - Operators
  - Overview
  - Reference
---
<div>{{JSSidebar("Operators")}}</div>

<p class="summary">This chapter documents all the JavaScript language operators, expressions and keywords.</p>

<h2 id="Expressions_and_operators_by_category">Expressions and operators by category</h2>

<p>For an alphabetical listing see the sidebar on the left.</p>

<h3 id="Primary_expressions">Primary expressions</h3>

<p>Basic keywords and general expressions in JavaScript.</p>

<dl>
 <dt>{{JSxRef("Operators/this", "this")}}</dt>
 <dd>The <code>this</code> keyword refers to a special property of an execution context.</dd>
 <dt>{{JSxRef("Operators/function", "function")}}</dt>
 <dd>The <code>function</code> keyword defines a function expression.</dd>
 <dt>{{JSxRef("Operators/class", "class")}}</dt>
 <dd>The <code>class</code> keyword defines a class expression.</dd>
 <dt>{{JSxRef("Operators/function*", "function*")}}</dt>
 <dd>The <code>function*</code> keyword defines a generator function expression.</dd>
 <dt>{{JSxRef("Operators/yield", "yield")}}</dt>
 <dd>Pause and resume a generator function.</dd>
 <dt>{{JSxRef("Operators/yield*", "yield*")}}</dt>
 <dd>Delegate to another generator function or iterable object.</dd>
 <dt>{{JSxRef("Operators/async_function", "async function")}}</dt>
 <dd>The <code>async function</code> defines an async function expression.</dd>
 <dt>{{JSxRef("Operators/await", "await")}}</dt>
 <dd>Pause and resume an async function and wait for the promise's resolution/rejection.</dd>
 <dt>{{JSxRef("Global_Objects/Array", "[]")}}</dt>
 <dd>Array initializer/literal syntax.</dd>
 <dt>{{JSxRef("Operators/Object_initializer", "{}")}}</dt>
 <dd>Object initializer/literal syntax.</dd>
 <dt>{{JSxRef("Global_Objects/RegExp", "/ab+c/i")}}</dt>
 <dd>Regular expression literal syntax.</dd>
 <dt>{{JSxRef("Operators/Grouping", "( )")}}</dt>
 <dd>Grouping operator.</dd>
</dl>

<h3 id="Left-hand-side_expressions">Left-hand-side expressions</h3>

<p>Left values are the destination of an assignment.</p>

<dl>
 <dt>{{JSxRef("Operators/Property_accessors", "Property accessors", "", 1)}}</dt>
 <dd>Member operators provide access to a property or method of an object<br>
 (<code>object.property</code> and <code>object["property"]</code>).</dd>
 <dt>{{JSxRef("Operators/new", "new")}}</dt>
 <dd>The <code>new</code> operator creates an instance of a constructor.</dd>
 <dt>{{JSxRef("Operators/new%2Etarget", "new.target")}}</dt>
 <dd>In constructors, <code>new.target</code> refers to the constructor that was invoked by {{JSxRef("Operators/new", "new")}}.</dd>
 <dt>{{JSxRef("Statements/import%2Emeta", "import.meta")}}</dt>
 <dd>An object exposing context-specific metadata to a JavaScript module.</dd>
 <dt>{{JSxRef("Operators/super", "super")}}</dt>
 <dd>The <code>super</code> keyword calls the parent constructor.</dd>
 <dt>{{JSxRef("Operators/Spread_syntax", "...obj")}}</dt>
 <dd>Spread syntax allows an expression to be expanded in places where multiple arguments (for function calls) or multiple elements (for array literals) are expected.</dd>
</dl>

<h3 id="Increment_and_decrement">Increment and decrement</h3>

<p>Postfix/prefix increment and postfix/prefix decrement operators.</p>

<dl>
 <dt>{{JSxRef("Operators/Increment", "A++")}}</dt>
 <dd>Postfix increment operator.</dd>
 <dt>{{JSxRef("Operators/Decrement", "A--")}}</dt>
 <dd>Postfix decrement operator.</dd>
 <dt>{{JSxRef("Operators/Increment", "++A")}}</dt>
 <dd>Prefix increment operator.</dd>
 <dt>{{JSxRef("Operators/Decrement", "--A")}}</dt>
 <dd>Prefix decrement operator.</dd>
</dl>

<h3 id="Unary_operators">Unary operators</h3>

<p>A unary operation is an operation with only one operand.</p>

<dl>
 <dt>{{JSxRef("Operators/delete", "delete")}}</dt>
 <dd>The <code>delete</code> operator deletes a property from an object.</dd>
 <dt>{{JSxRef("Operators/void", "void")}}</dt>
 <dd>The <code>void</code> operator discards an expression's return value.</dd>
 <dt>{{JSxRef("Operators/typeof", "typeof")}}</dt>
 <dd>The <code>typeof</code> operator determines the type of a given object.</dd>
 <dt>{{JSxRef("Operators/Unary_plus", "+")}}</dt>
 <dd>The unary plus operator converts its operand to Number type.</dd>
 <dt>{{JSxRef("Operators/Unary_negation", "-")}}</dt>
 <dd>The unary negation operator converts its operand to Number type and then negates it.</dd>
 <dt>{{JSxRef("Operators/Bitwise_NOT", "~")}}</dt>
 <dd>Bitwise NOT operator.</dd>
 <dt>{{JSxRef("Operators/Logical_NOT", "!")}}</dt>
 <dd>Logical NOT operator.</dd>
</dl>

<h3 id="Arithmetic_operators">Arithmetic operators</h3>

<p>Arithmetic operators take numerical values (either literals or variables) as their operands and return a single numerical value.</p>

<dl>
 <dt>{{JSxRef("Operators/Addition", "+")}}</dt>
 <dd>Addition operator.</dd>
 <dt>{{JSxRef("Operators/Subtraction", "-")}}</dt>
 <dd>Subtraction operator.</dd>
 <dt>{{JSxRef("Operators/Division", "/")}}</dt>
 <dd>Division operator.</dd>
 <dt>{{JSxRef("Operators/Multiplication", "*")}}</dt>
 <dd>Multiplication operator.</dd>
 <dt>{{JSxRef("Operators/Remainder", "%")}}</dt>
 <dd>Remainder operator.</dd>
 <dt>{{JSxRef("Operators/Exponentiation", "**")}}</dt>
 <dd>Exponentiation operator.</dd>
</dl>

<h3 id="Relational_operators">Relational operators</h3>

<p>A comparison operator compares its operands and returns a <code>Boolean</code> value based on whether the comparison is true.</p>

<dl>
 <dt>{{JSxRef("Operators/in", "in")}}</dt>
 <dd>The <code>in</code> operator determines whether an object has a given property.</dd>
 <dt>{{JSxRef("Operators/instanceof", "instanceof")}}</dt>
 <dd>The <code>instanceof</code> operator determines whether an object is an instance of another object.</dd>
 <dt>{{JSxRef("Operators/Less_than", "&lt;")}}</dt>
 <dd>Less than operator.</dd>
 <dt>{{JSxRef("Operators/Greater_than", "&gt;")}}</dt>
 <dd>Greater than operator.</dd>
 <dt>{{JSxRef("Operators/Less_than_or_equal", "&lt;=")}}</dt>
 <dd>Less than or equal operator.</dd>
 <dt>{{JSxRef("Operators/Greater_than_or_equal", "&gt;=")}}</dt>
 <dd>Greater than or equal operator.</dd>
</dl>

<div class="notecard note">
<p><strong>Note: =&gt;</strong> is not an operator, but the notation for <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">Arrow functions</a>.</p>
</div>

<h3 id="Equality_operators">Equality operators</h3>

<p>The result of evaluating an equality operator is always of type <code>Boolean</code> based on whether the comparison is true.</p>

<dl>
 <dt>{{JSxRef("Operators/Equality", "==")}}</dt>
 <dd>Equality operator.</dd>
 <dt>{{JSxRef("Operators/Inequality", "!=")}}</dt>
 <dd>Inequality operator.</dd>
 <dt>{{JSxRef("Operators/Strict_equality", "===")}}</dt>
 <dd>Identity operator.</dd>
 <dt>{{JSxRef("Operators/Strict_inequality", "!==")}}</dt>
 <dd>Nonidentity operator.</dd>
</dl>

<h3 id="Bitwise_shift_operators">Bitwise shift operators</h3>

<p>Operations to shift all bits of the operand.</p>

<dl>
 <dt>{{JSxRef("Operators/Left_shift", "&lt;&lt;")}}</dt>
 <dd>Bitwise left shift operator.</dd>
 <dt>{{JSxRef("Operators/Right_shift", "&gt;&gt;")}}</dt>
 <dd>Bitwise right shift operator.</dd>
 <dt>{{JSxRef("Operators/Unsigned_right_shift", "&gt;&gt;&gt;")}}</dt>
 <dd>Bitwise unsigned right shift operator.</dd>
</dl>

<h3 id="Binary_bitwise_operators">Binary bitwise operators</h3>

<p>Bitwise operators treat their operands as a set of 32 bits (zeros and ones) and return standard JavaScript numerical values.</p>

<dl>
 <dt>{{JSxRef("Operators/Bitwise_AND", "&amp;")}}</dt>
 <dd>Bitwise AND.</dd>
 <dt>{{JSxRef("Operators/Bitwise_OR", "|")}}</dt>
 <dd>Bitwise OR.</dd>
 <dt>{{JSxRef("Operators/Bitwise_XOR", "^")}}</dt>
 <dd>Bitwise XOR.</dd>
</dl>

<h3 id="Binary_logical_operators">Binary logical operators</h3>

<p>Logical operators are typically used with boolean (logical) values, and when they are, they return a boolean value.</p>

<dl>
 <dt>{{JSxRef("Operators/Logical_AND", "&amp;&amp;")}}</dt>
 <dd>Logical AND.</dd>
 <dt>{{JSxRef("Operators/Logical_OR", "||")}}</dt>
 <dd>Logical OR.</dd>
 <dt>{{JSxRef("Operators/Nullish_coalescing_operator", "??")}}</dt>
 <dd>Nullish Coalescing Operator.</dd>
</dl>

<h3 id="Conditional_ternary_operator">Conditional (ternary) operator</h3>

<dl>
 <dt>{{JSxRef("Operators/Conditional_Operator", "(condition ? ifTrue : ifFalse)")}}</dt>
 <dd>
 <p>The conditional operator returns one of two values based on the logical value of the condition.</p>
 </dd>
</dl>

<h3 id="Optional_Chaining_operator">Optional Chaining operator</h3>

<dl>
 <dt>{{JSxRef("Operators/Optional_chaining", "?.")}}</dt>
 <dd>
 <p>The optional chaining operator returns <code>undefined</code> instead of causing an error if a reference is <a href="/en-US/docs/Glossary/nullish">nullish</a> (<a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/null"><code>null</code></a> or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/undefined"><code>undefined</code></a>).</p>
 </dd>
</dl>

<h3 id="Assignment_operators">Assignment operators</h3>

<p>An assignment operator assigns a value to its left operand based on the value of its right operand.</p>

<dl>
 <dt>{{JSxRef("Operators/Assignment", "=")}}</dt>
 <dd>Assignment operator.</dd>
 <dt>{{JSxRef("Operators/Multiplication_assignment", "*=")}}</dt>
 <dd>Multiplication assignment.</dd>
 <dt>{{JSxRef("Operators/Exponentiation_assignment", "**=")}}</dt>
 <dd>Exponentiation assignment.</dd>
 <dt>{{JSxRef("Operators/Division_assignment", "/=")}}</dt>
 <dd>Division assignment.</dd>
 <dt>{{JSxRef("Operators/Remainder_assignment", "%=")}}</dt>
 <dd>Remainder assignment.</dd>
 <dt>{{JSxRef("Operators/Addition_assignment", "+=")}}</dt>
 <dd>Addition assignment.</dd>
 <dt>{{JSxRef("Operators/Subtraction_assignment", "-=")}}</dt>
 <dd>Subtraction assignment</dd>
 <dt>{{JSxRef("Operators/Left_shift_assignment", "&lt;&lt;=")}}</dt>
 <dd>Left shift assignment.</dd>
 <dt>{{JSxRef("Operators/Right_shift_assignment", "&gt;&gt;=")}}</dt>
 <dd>Right shift assignment.</dd>
 <dt>{{JSxRef("Operators/Unsigned_right_shift_assignment", "&gt;&gt;&gt;=")}}</dt>
 <dd>Unsigned right shift assignment.</dd>
 <dt>{{JSxRef("Operators/Bitwise_AND_assignment", "&amp;=")}}</dt>
 <dd>Bitwise AND assignment.</dd>
 <dt>{{JSxRef("Operators/Bitwise_XOR_assignment", "^=")}}</dt>
 <dd>Bitwise XOR assignment.</dd>
 <dt>{{JSxRef("Operators/Bitwise_OR_assignment", "|=")}}</dt>
 <dd>Bitwise OR assignment.</dd>
 <dt>{{JSxRef("Operators/Logical_AND_assignment", "&amp;&amp;=")}}</dt>
 <dd>Logical AND assignment.</dd>
 <dt>{{JSxRef("Operators/Logical_OR_assignment", "||=")}}</dt>
 <dd>Logical OR assignment.</dd>
 <dt>{{JSxRef("Operators/Logical_nullish_assignment", "??=")}}</dt>
 <dd>Logical nullish assignment.</dd>
 <dt>{{JSxRef("Operators/Destructuring_assignment", "[a, b] = [1, 2]")}}<br>
 {{JSxRef("Operators/Destructuring_assignment", "{a, b} = {a:1, b:2}")}}</dt>
 <dd>
 <p>Destructuring assignment allows you to assign the properties of an array or object to variables using syntax that looks similar to array or object literals.</p>
 </dd>
</dl>

<h3 id="Comma_operator">Comma operator</h3>

<dl>
 <dt>{{JSxRef("Operators/Comma_Operator", ",")}}</dt>
 <dd>The comma operator allows multiple expressions to be evaluated in a single statement and returns the result of the last expression.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-ecmascript-language-expressions', 'ECMAScript Language: Expressions')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence">Operator precedence</a></li>
</ul>
